#!/bin/sh
# Script para inicializar directorios que consignaran información
# de un colegio apropiada para sigue
# Dominio público. Sin garantías. 2003. http://structio.sourceforge.net/sigue

if (test "$NOMBRE" = "") then {
	if (test "$SUDO_USER" != "") then {
		NOMBRE=$SUDO_USER;
	} else {
		NOMBRE=$USER;
	} fi;
} fi;

INSXML=/usr/local/share/xml/structio
INSDATA=/usr/local/share/sigue
INSBIN=/usr/local/bin
REPDATA=/usr/local/share/repasa

if (test "$1" = "") then {
	echo "El primer parámetro debe ser el directorio por crear";
	exit 1;
} fi;
dir=$1;

if (test "$2" = "") then {
	echo "El segundo parámetro debe ser año en el cual comenzará a usarse";
	exit 1;
} fi;
anio=$2;
if (test  "$HOME" != "/root" -a "$USER" != "root") then { 
	echo "No se efectuarán cambio de propietario por no ejecutar como root.";
	echo "Enter para continuar.";
	read;
} fi;


dirf="$INSDATA/ejemplos/nuestra-escuela"

mkdir -p $dir
sed -e "s|2004|$anio|g" $dirf/cron.sec > $dir/cron.sec;
touch $dir/dic.ispell
cp $dirf/{Makefile,Make.inc}  $dir/;
cp $REPDATA/ejemplos/planest/.cvsignore  $dir/;
if (test ! -d $dir/estudiante) then {
	echo "Creando plantilla para directorio estudiante";
	mkdir -p $dir/estudiante
	sed -e "s|2004|$anio|g" $dirf/estudiante/Makefile > $dir/estudiante/Makefile;
	mkdir -p $dir/estudiante/1980
	mkdir -p $dir/estudiante/1980/robcar
	cp -rf $dirf/estudiante/1980/robcar/datos.ind $dir/estudiante/1980/robcar/datos.ind
	for i in 1 2 3 4 5 6 7 8 9 10 11; do 
		mkdir -p $dir/estudiante/1980/estej$i;
		cp -rf $dirf/estudiante/1980/estej$i/datos.ind $dir/estudiante/1980/estej$i/;
	done;
} fi;

if (test ! -d $dir/profesor) then {
	echo "Creando plantilla para directorio profesor";
	mkdir -p $dir/profesor;
	cp -rf $dirf/profesor/Makefile $dir/profesor/;
	mkdir -p $dir/profesor/1965;
	mkdir -p $dir/profesor/1965/jergon;
	cp -rf $dirf/profesor/1965/jergon/datos.ind $dir/profesor/1965/jergon/;
	mkdir -p $dir/profesor/1970;
	mkdir -p $dir/profesor/1970/pepsub;
	cp -rf $dirf/profesor/1970/pepsub/datos.ind $dir/profesor/1970/pepsub/;
} fi;


if (test ! -d $dir/grupo) then {
	echo "Creando plantilla para directorio grupo";
	mkdir -p $dir/grupo
	mkdir -p $dir/grupo/$anio
	mkdir -p $dir/grupo/$anio/bprimaria
	mkdir -p $dir/grupo/$anio/bsecundaria
	mkdir -p $dir/grupo/$anio/media
	sed -e "s|2004|$anio|g" $dirf/grupo/Makefile > $dir/grupo/Makefile;
	cp -rf $dirf/grupo/2004/*grp $dir/grupo/$anio/
	cp -rf $dirf/grupo/2004/bprimaria/g*.grp $dir/grupo/$anio/bprimaria
	cp -rf $dirf/grupo/2004/bsecundaria/g*.grp $dir/grupo/$anio/bsecundaria
	cp -rf $dirf/grupo/2004/media/g*.grp $dir/grupo/$anio/media
} fi;

if (test ! -d $dir/planest) then {
	echo "Creando plantilla para directorio planest (los archivos para asignaturas serán creados de acuerdo al plan de estudio por el script perm.sh)";
	mkdir -p $dir/planest;
	mkdir -p $dir/planest/$anio;
	sed -e "s|xslt[ ]*=.*|xslt=\"$INSDATA/xslt/planest2perm.xsl\"|g;s|catalogo[ ]*=.*|catalogo=\"$INSXML/catalog\"|g" $dirf/planest/creaperm.sh > $dir/planest/creaperm.sh;
	sed -e "s|nuestra-escuela|$dir|g" $dirf/planest/revisaort.sh > $dir/planest/revisaort.sh;
	cp $dirf/planest/{Makefile,inip.sh,inifinal.sh}  $dir/planest;
	for i in col g1 g2 g3 g4 g5 g6 g7 g8 g9 g10 g11; do
		sed -e "s|grupo/2004|grupo/$anio|g;s|planest\/2004|planest\/$anio|g" $dirf/planest/2004/$i.planest > $dir/planest/$anio/$i.planest;
	done;
	mkdir -p $dir/planest/$anio/bprimaria;
	mkdir -p $dir/planest/$anio/bsecundaria;
	mkdir -p $dir/planest/$anio/media;
	mkdir -p $dir/planest/$anio/bprimaria/1/;
	cp -f $REPDATA/ejemplos/planest/2004/bprimaria/1/Makefile $dir/planest/$anio/bprimaria/1/;
	for i in bprimaria/1 bprimaria/2 bprimaria/3 bprimaria/4 bprimaria/5 bsecundaria/6 bsecundaria/7 bsecundaria/8 bsecundaria/9 media/10 media/11; do
		mkdir -p $dir/planest/$anio/$i/;
#		cp -f $REPDATA/ejemplos/planest/2004/$i/*.{cla,def} $dir/planest/$anio/$i/;
#		for j in $REPDATA/ejemplos/planest/2004/$i/*.sec ; do
#			n=`basename $j`;
#			sed -e "s|2004|$anio|g" $j > $dir/planest/$anio/$i/$n;
#		done;
	done;
	sed -e "s|2004|$anio|g" $REPDATA/ejemplos/planest/chqperm.sh > $dir/planest/chqperm.sh
	sed -e "s|2004|$anio|g" $REPDATA/ejemplos/planest/enlaces.sh > $dir/planest/enlaces.sh
	cp -f $REPDATA/ejemplos/planest/{genhtml.sh,Makefile,perm.sh} $dir/planest/
	sed -e "s|2004|$anio|g" $REPDATA/ejemplos/planest/2004/perm.sh > $dir/planest/$anio/perm.sh
	chmod +x $dir/planest/{chqperm.sh,creaperm.sh,enlaces.sh,genhtml.sh,inip.sh,perm.sh}
	(cd  $dir/planest; ./enlaces.sh)
} fi;

if (test ! -d $dir/reporte) then {
	echo "Creando plantilla para directorio reporte";
	mkdir -p $dir/reporte;
	sed -e "s|INSBINREP[ ]*=.*|INSBINREP=$INSBIN|g;s|2004|$anio|g" $dirf/reporte/imprep.sh > $dir/reporte/imprep.sh;
	chmod +x $dir/reporte/imprep.sh;
	cp -f $dirf/reporte/genps.sh $dir/reporte/genps.sh;
	chmod +x $dir/reporte/genps.sh;
	mkdir -p $dir/reporte/$anio;
	l=`find "$dirf/reporte/2004" -type f | grep -v CVS`;
	cp -f $l $dir/reporte/$anio;
} fi;

chmod -R o-xrw,g+r-w,u+rw $dir
find $dir -type d -exec chmod gu+x {} ";"
chown -R root:profesor $dir

